#!/bin/bash

# {{ ansible_managed }}

export TZ=UTC

set -e

writer () {

  checksid=$1
  shift
  for pkg in $*; do
    shortpkg=$(echo $pkg | sed -e 's#/.*##')
    justpkg=$(echo $pkg | sed -e 's#_.*##')
    if [ $(ls -dt ${justpkg}_* | head -1) != $shortpkg ]; then
	continue
    fi
    linktgt=$(basename $(readlink -f $pkg))
    echo "<tr><td><a href=\"$shortpkg/$linktgt\">$shortpkg</a> (<a href=\"https://tracker.debian.org/$justpkg\">PTS</a>) </td>" >> $TMPREPORT
    if $checksid; then
        echo "<td>" >> $TMPREPORT
	sidfile="../../sid/pool/$pkg"
	if [ -e "$sidfile" ] && [ "$sidfile" -nt "$pkg" ]; then
		res=$(sed -n 's/^Status: // p' "$sidfile" | tail -1)
		res=${res:-?}
		if [ "$res" = "successful" ]; then
			res="<b>$res</b>"
		fi
		echo "<a href=\"../sid/$pkg\">$res</a>" >> $TMPREPORT
	else
		echo "n/a" >> $TMPREPORT
	fi
    fi
    echo "<td>" >> $TMPREPORT
    stat -c '%y' $pkg | sed 's/\.[0-9]*//' >> $TMPREPORT
    echo "</td></tr>" >> $TMPREPORT
  done

}

mainheader () {
    cat <<EOF > $TMPREPORT
<html>
<head>
<script type="text/javascript" src="/javascript/jquery/jquery.js"></script>
<script type="text/javascript" src="/javascript/jquery-tablesorter/jquery.tablesorter.js"></script>
<link type="text/css"
    href="/javascript/jquery-tablesorter/css/theme.blue.css"
    rel="stylesheet" />
<title>perl rebuild failed log report: $1</title>
</head>
<body>
<h2>perl rebuild failed log report: $1</h2>

<p>Generated: 
EOF
    date >> $TMPREPORT
}

mainfooter () {
    cat <<'EOF' >> $TMPREPORT
<script type="text/javascript">
$(document).ready(function()
    {
EOF
    for what in $*; do
cat <<EOF >> $TMPREPORT
        \$("#$what").tablesorter();
EOF
    done
    cat <<"EOF" >> $TMPREPORT
    }
);
</script>
</body>
</html>
EOF
}

counter () {
    what="$1"
    desc="$2"
    findopts=
    if [ -e CUTOFF ]; then
	findopts=" -newer CUTOFF"
    fi
    filelist=$(mktemp)
    find . -name '*.buildlog' $findopts -printf "%T@ %p\n" > $filelist
    since=$(date -d @$(sort -n $filelist | head -1 | sed 's/\..*//'))
    failures_count=$(cut -d' ' -f2- $filelist | xargs --no-run-if-empty grep -l "^Status: $what" | wc -l)
    all_count=$(wc -l < $filelist)
    rm $filelist
    cat <<EOF >> $TMPREPORT
<h3>$desc ("$what")</h3>
$failures_count of $all_count since $since
EOF
}

tablewriter () {
    what="$1"
    desc="$2"
    checksid=true
    findopts=
    if $checksid; then
	sidcolumn="  <th>Latest sid result</th>"
    fi
    if [ -e CUTOFF ]; then
	findopts=" -newer CUTOFF"
    fi
    packages=$(find . -name '*.buildlog' $findopts | xargs --no-run-if-empty grep -l "^Status: $what" | sed 's,^./,,' | xargs --no-run-if-empty ls -t)
    cat <<EOF >> $TMPREPORT
<h3>$desc ("$what")</h3>
<table id="$what" class="tablesorter-blue">
<thead>
<tr>
  <th>Package</th>
$sidcolumn
  <th>Date</th>
</tr>
</thead>
<tbody>
EOF
    writer $checksid $packages
    cat <<"EOF" >> $TMPREPORT
</tbody>
</table>
EOF

}

if [ -z "$1" ]; then
    echo "Usage: $0 <dist> [...]"
    exit 1
fi

for dist in $*; do
    dir=/srv/debomatic/incoming/$dist/pool

    cd $dir

    TMPREPORT=$(mktemp)
    chmod 644 $TMPREPORT

    mainheader $dist
    counter successful "Successful builds"
    tablewriter attempted "Build failures"
    tablewriter failed "Possibly transient failures"
    tablewriter given-back "Dependency problems"
    mainfooter attempted failed given-back

    mv $TMPREPORT report.html
done

exit 0
